Loading...
Searching...
No Matches
uhd::transport::usb_device_handle Class Referenceabstract

`#include <uhd/transport/usb_device_handle.hpp>`

Inheritance diagram for uhd::transport::usb_device_handle:
[legend]
Collaboration diagram for uhd::transport::usb_device_handle:
[legend]

## Public Types

typedef std::shared_ptr< usb_device_handle > | sptr
typedef std::pair< uint16_t, uint16_t > | vid_pid_pair_t

## Public Member Functions

virtual | ~usb_device_handle (void)
virtual std::string | get_serial () const =0
virtual std::string | get_manufacturer () const =0
virtual std::string | get_product () const =0
virtual uint16_t | get_vendor_id () const =0
virtual uint16_t | get_product_id () const =0
virtual bool | firmware_loaded ()=0

## Static Public Member Functions

static std::vector< usb_device_handle::sptr > | get_device_list (uint16_t vid, uint16_t pid)
static std::vector< usb_device_handle::sptr > | get_device_list (const std::vector< usb_device_handle::vid_pid_pair_t > &vid_pid_pair_list)

## Detailed Description

Device handle class that represents a USB device Used for identifying devices on the USB bus and selecting which device is used when creating a USB transport. A minimal subset of USB descriptor fields are used. Fields can be found in the USB 2.0 specification Table 9-8 (Standard Device Descriptor). In addition to fields of the device descriptor, the interface returns the device's USB device address.

Note: The USB 2.0 Standard Device Descriptor contains an index rather then a true descriptor serial number string. This interface returns the actual string descriptor.

## Member Typedef Documentation

## sptr

typedef std::shared_ptr<usb_device_handle> uhd::transport::usb_device_handle::sptr

## vid_pid_pair_t

typedef std::pair<uint16_t, uint16_t> uhd::transport::usb_device_handle::vid_pid_pair_t

## Constructor & Destructor Documentation

## ~usb_device_handle()

virtual uhd::transport::usb_device_handle::~usb_device_handle | ( | void |  | ) |

virtual

## Member Function Documentation

## firmware_loaded()

virtual bool uhd::transport::usb_device_handle::firmware_loaded | ( |  | ) |

pure virtual

Test whether the firmware is loaded on the device.

Returns
  true if firmware is loaded

## get_device_list() [1/2]

std::vector< usb_device_handle::sptr > uhd::transport::usb_device_handle::get_device_list | ( | const std::vector< usb_device_handle::vid_pid_pair_t > & | vid_pid_pair_list | ) |

static

## get_device_list() [2/2]

std::vector< usb_device_handle::sptr > uhd::transport::usb_device_handle::get_device_list | ( | uint16_t | vid,
|  | uint16_t | pid )

static

Return a vector of USB devices on this host

Returns
  a vector of USB device handles that match vid and pid

## get_manufacturer()

virtual std::string uhd::transport::usb_device_handle::get_manufacturer | ( |  | ) | const

pure virtual

Return the device's manufacturer identification string

Returns
  a string describing the device's manufacturer string

## get_product()

virtual std::string uhd::transport::usb_device_handle::get_product | ( |  | ) | const

pure virtual

Return the device's product identification string

Returns
  a string describing the device's product string

## get_product_id()

virtual uint16_t uhd::transport::usb_device_handle::get_product_id | ( |  | ) | const

pure virtual

Return the device's Product ID (usually assigned by manufacturer)

Returns
  a Product ID

## get_serial()

virtual std::string uhd::transport::usb_device_handle::get_serial | ( |  | ) | const

pure virtual

Return the device's serial number

Returns
  a string describing the device's serial number

## get_vendor_id()

virtual uint16_t uhd::transport::usb_device_handle::get_vendor_id | ( |  | ) | const

pure virtual

Return the device's Vendor ID (usually assigned by the USB-IF)

Returns
  a Vendor ID

The documentation for this class was generated from the following file:

- usb_device_handle.hpp